searchNodes=[{"doc":"Membrane element that decodes video in H264 format. It is backed by decoder from FFmpeg. The element expects the data for each frame (Access Unit) to be received in a separate buffer, so the parser ( Membrane.H264.FFmpeg.Parser ) may be required in a pipeline before decoder (e.g. when input is read from Membrane.File.Source ). Element options Passed via struct Membrane.H264.FFmpeg.Decoder.t/0 use_shm? boolean Default value: false Pads :input Availability :always Caps Membrane.H264 , restrictions: &nbsp;&nbsp; stream_format: :byte_stream , &nbsp;&nbsp; alignment: :au Demand mode :auto Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps Membrane.RawVideo , restrictions: &nbsp;&nbsp; pixel_format: one_of([:I420, :I422]) , &nbsp;&nbsp; aligned: true Demand mode :auto Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.H264.FFmpeg.Decoder.html","title":"Membrane.H264.FFmpeg.Decoder","type":"module"},{"doc":"Returns pads descriptions for Membrane.H264.FFmpeg.Decoder","ref":"Membrane.H264.FFmpeg.Decoder.html#membrane_pads/0","title":"Membrane.H264.FFmpeg.Decoder.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Decoder.html#options/0","title":"Membrane.H264.FFmpeg.Decoder.options/0","type":"function"},{"doc":"Struct containing options for Membrane.H264.FFmpeg.Decoder","ref":"Membrane.H264.FFmpeg.Decoder.html#t:t/0","title":"Membrane.H264.FFmpeg.Decoder.t/0","type":"type"},{"doc":"Membrane element that encodes raw video frames to H264 format. The element expects each frame to be received in a separate buffer, so the parser ( Membrane.Element.RawVideo.Parser ) may be required in a pipeline before the encoder (e.g. when input is read from Membrane.File.Source ). Additionally, the encoder has to receive proper caps with picture format and dimensions before any encoding takes place. Please check t/0 for available options. Element options Passed via struct Membrane.H264.FFmpeg.Encoder.t/0 crf any Default value: 23 Constant rate factor that affects the quality of output stream. Value of 0 is lossless compression while 51 (for 8-bit samples) or 63 (10-bit) offers the worst quality. The range is exponential, so increasing the CRF value +6 results in roughly half the bitrate / file size, while -6 leads to roughly twice the bitrate. preset presets ( ) Default value: :medium Collection of predefined options providing certain encoding. The slower the preset chosen, the higher compression for the same quality can be achieved. profile H264 . profile_t ( ) | nil Default value: nil Sets a limit on the features that the encoder will use to the ones supported in a provided H264 profile. Said features will have to be supported by the decoder in order to decode the resulting video. It may override other, more specific options affecting compression (e.g setting max_b_frames to 2 while profile is set to :baseline will have no effect and no B-frames will be present). use_shm? boolean Default value: false max_b_frames any Default value: nil Maximum number of B-frames between non-B-frames. Set to 0 to encode video without b-frames Pads :input Availability :always Caps Membrane.RawVideo , restrictions: &nbsp;&nbsp; pixel_format: one_of([:I420, :I422]) , &nbsp;&nbsp; aligned: true Demand mode :auto Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps Membrane.H264 , restrictions: &nbsp;&nbsp; stream_format: :byte_stream , &nbsp;&nbsp; alignment: :au Demand mode :auto Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.H264.FFmpeg.Encoder.html","title":"Membrane.H264.FFmpeg.Encoder","type":"module"},{"doc":"Returns pads descriptions for Membrane.H264.FFmpeg.Encoder","ref":"Membrane.H264.FFmpeg.Encoder.html#membrane_pads/0","title":"Membrane.H264.FFmpeg.Encoder.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Encoder.html#options/0","title":"Membrane.H264.FFmpeg.Encoder.options/0","type":"function"},{"doc":"","ref":"Membrane.H264.FFmpeg.Encoder.html#t:presets/0","title":"Membrane.H264.FFmpeg.Encoder.presets/0","type":"type"},{"doc":"Struct containing options for Membrane.H264.FFmpeg.Encoder","ref":"Membrane.H264.FFmpeg.Encoder.html#t:t/0","title":"Membrane.H264.FFmpeg.Encoder.t/0","type":"type"},{"doc":"Membrane element providing parser for H264 encoded video stream. Uses the parser provided by FFmpeg. By default, this parser splits the stream into h264 access units, each of which is a sequence of NAL units corresponding to one video frame, and equips them with the following metadata entries under :h264 key: key_frame?: boolean - determines whether the frame is a h264 I frame. Setting custom packetization options affects metadata, see alignment and attach_nalus? options for details. Element options Passed via struct Membrane.H264.FFmpeg.Parser.t/0 framerate H264 . framerate_t ( ) | nil Default value: nil Framerate of video stream, see t:Membrane.Caps.Video.H264.framerate_t/0 sps any Default value: &quot;&quot; Sequence Parameter Set NAL unit - if absent in the stream, should be provided via this option. pps any Default value: &quot;&quot; Picture Parameter Set NAL unit - if absent in the stream, should be provided via this option. alignment :au | :nal Default value: :au Stream units carried by each output buffer. See t:Membrane.Caps.Video.H264.alignment_t . If alignment is :nal , the following metadata entries are added: type - h264 nalu type new_access_unit: access_unit_metadata - added whenever the new access unit starts. access_unit_metadata is the metadata that would be merged into the buffer metadata normally (if alignment was :au ). end_access_unit: true - added for each NALu that ends an access unit. attach_nalus? boolean Default value: false Determines whether to attach NAL units list to the metadata when alignment option is set to :au . For details see t:Membrane.Caps.Video.H264.nalu_in_metadata_t/0 . skip_until_keyframe? boolean Default value: false Determines whether to drop the stream until the first key frame is received. skip_until_parameters? boolean Default value: true Determines whether to drop the stream until the first set of SPS and PPS is received. Pads :input Availability :always Caps :any Demand mode :auto Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps Membrane.H264 , restrictions: &nbsp;&nbsp; stream_format: :byte_stream Demand mode :auto Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.H264.FFmpeg.Parser.html","title":"Membrane.H264.FFmpeg.Parser","type":"module"},{"doc":"Returns pads descriptions for Membrane.H264.FFmpeg.Parser","ref":"Membrane.H264.FFmpeg.Parser.html#membrane_pads/0","title":"Membrane.H264.FFmpeg.Parser.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Parser.html#options/0","title":"Membrane.H264.FFmpeg.Parser.options/0","type":"function"},{"doc":"Struct containing options for Membrane.H264.FFmpeg.Parser","ref":"Membrane.H264.FFmpeg.Parser.html#t:t/0","title":"Membrane.H264.FFmpeg.Parser.t/0","type":"type"},{"doc":"Utility functions for parsing AVC Configuration Record","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration","type":"module"},{"doc":"","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html#parse/1","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.parse/1","type":"function"},{"doc":"","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html#t:t/0","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.t/0","type":"type"},{"doc":"This package provides H264 video parser, decoder and encoder, based on ffmpeg and x264 . It is a part of the Membrane Multimedia Framework Documentation is available at HexDocs","ref":"readme.html","title":"Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"Add the following line to your deps in mix.exs . Run mix deps.get . { :membrane_h264_ffmpeg_plugin , &quot;~&gt; 0.20.1&quot; } You also need to have ffmpeg libraries installed in your system. Ubuntu sudo apt-get install libavcodec-dev libavformat-dev libavutil-dev Arch/Manjaro pacman -S ffmpeg MacOS brew install ffmpeg","ref":"readme.html#installation","title":"Membrane H264 FFmpeg plugin - Installation","type":"extras"},{"doc":"Decoder The following pipeline takes 30fps H264 file and decodes it to the raw video. defmodule Decoding.Pipeline do use Membrane.Pipeline @impl true def handle_init ( _ ) do children = [ source : % Membrane.File.Source { chunk_size : 40_960 , location : &quot;input.h264&quot; } , parser : % H264.FFmpeg.Parser { framerate : { 30 , 1 } } , decoder : H264.FFmpeg.Decoder , sink : % Membrane.File.Sink { location : &quot;output.raw&quot; } ] links = [ link ( :source ) |&gt; to ( :parser ) |&gt; to ( :decoder ) |&gt; to ( :sink ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , %{ } } end end Encoder The following pipeline takes 720p raw video file as input and encodes it as H264. defmodule Encoding.Pipeline do use Membrane.Pipeline @impl true def handle_init ( _ ) do children = [ source : % Membrane.File.Source { chunk_size : 40_960 , location : &quot;input.raw&quot; } , parser : % Membrane.RawVideo.Parser { width : 1280 , height : 720 , pixel_format : :I420 } , encoder : % Membrane.H264.FFmpeg.Encoder { preset : :fast , crf : 30 } , sink : % Membrane.File.Sink { location : &quot;output.h264&quot; } ] links = [ link ( :source ) |&gt; to ( :parser ) |&gt; to ( :encoder ) |&gt; to ( :sink ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , %{ } } end end","ref":"readme.html#usage-example","title":"Membrane H264 FFmpeg plugin - Usage Example","type":"extras"},{"doc":"Copyright 2018, Software Mansion","ref":"readme.html#copyright-and-license","title":"Membrane H264 FFmpeg plugin - Copyright and License","type":"extras"}]